/// This is where to put various behaviors that cannot fit in a hook

#include "game_hooks.h"
#include <graphics/graphics.h>
#include <SCBW/api.h>
#include "../psi_field.h"
#include <cstdio>
#include <modding/game_hooks_drawing.h>

namespace hooks {

/// This hook is called every frame.
bool nextFrame() {

	if (!scbw::isGamePaused()) { //If the game is not paused

		scbw::setInGameLoopState(true); //Needed for scbw::random() to work
		graphics::resetAllGraphics();
		hooks::updatePsiFieldProviders();

		modding::drawRallyAndOthersForSelectedUnits();

		scbw::setInGameLoopState(false);

	}

	return true;

}

;

bool gameOn() {
	return true;
}

;

bool gameEnd() {
	return true;
}

;

} //hooks
