#include "multi_select_mods.h"

namespace modding {

	//modded version of unit_IsStandardAndMovable for multi-select
	//must return true if multi-select is acceptable for the unit
	bool unit_IsStandardAndMovable_modded(CUnit* unit) {

		bool return_value;

		if (
			//units_dat::BaseProperty[unit->id] & UnitProperty::Building || //individual cases to disable handled elsewhere
			units_dat::BaseProperty[unit->id] & UnitProperty::NeutralAccessories ||
			unit->status & UnitStatus::DoodadStatesThing ||
			unit->lockdownTimer != 0 ||
			unit->stasisTimer != 0 ||
			unit->maelstromTimer != 0 ||
			(
				unit->id >= UnitId::Special_FloorMissileTrap &&
				unit->id <= UnitId::Special_RightWallFlameTrap
				) ||
			unit->id == UnitId::TerranVultureSpiderMine ||
			//unit->id == UnitId::ZergEgg ||			//disabled to allow for rally points, eggs can be multi-select through multi-morph but not after
			unit->id == UnitId::Critter_Rhynadon ||
			unit->id == UnitId::Critter_Bengalaas ||
			unit->id == UnitId::Critter_Ragnasaur ||
			unit->id == UnitId::Critter_Kakaru ||
			unit->id == UnitId::Critter_Scantid ||
			unit->id == UnitId::Critter_Ursadon ||
			unit->id == UnitId::Spell_DarkSwarm ||
			unit->id == UnitId::Spell_DisruptionWeb
			)
			return_value = false;
		else
			return_value = true;

		return return_value;

	} //bool unit_IsStandardAndMovable(CUnit* unit)

	;

};